<template>
  <base-button-icon
    :color="color"
    :href="href"
    :size="size"
    icon="envelope"
    tooltip-text="Email Link"
  />
</template>

<script lang="ts">
import Vue, { PropOptions } from 'vue';
import { Locus } from '@/common/types';

import BaseButtonIcon from '@/components/BaseButtonIcon.vue';

export default Vue.extend({
  components: {
    BaseButtonIcon,
  },

  props: {
    color: {
      default: 'gray',
      required: false,
      type: String,
    },

    locus: {
      required: true,
      type: Object,
    } as PropOptions<Locus>,

    size: {
      default: 'md',
      required: false,
      type: String,
    },
  },

  computed: {
    body(): string {
      const { href } = this.$router.resolve({
        name: 'locusDetail',
        params: { locusId: this.locus.id },
      });
      return `${(<any> this).ANTARES_FRONTEND_URL}${href}`;
    },

    href(): string {
      return `mailto:?body=${this.body}&subject=${this.subject}`;
    },

    subject(): string {
      return `ANTARES: ${this.locus.properties.ztf_object_id}`;
    },
  },
});
</script>
